;;; AC2PG Transforme l'arc ou le cercle slectionn en polygone.

(defun c:ac2pg (/ ent nb obj n dist lst)
  (vl-load-com)
  (if (and (setq ent (car (entsel "\nSlectionnez un arc ou un cercle: ")))
	   (or (= (cdr (assoc 0 (entget ent))) "ARC")
	       (= (cdr (assoc 0 (entget ent))) "CIRCLE")
	   )
      )
    (progn
      (initget 7)
      (setq nb	 (getint "\nEntrez le nombre de segments: ")
	    obj	 (vlax-ename->vla-object ent)
	    dist (/ (vlax-curve-getDistAtParam
		      obj
		      (vlax-curve-getEndParam obj)
		    )
		    nb
		 )
	    lst	 (list (vlax-curve-getStartPoint obj))
	    n	 0
      )
      (repeat nb
	(setq
	  lst
	   (cons
	     (vlax-curve-getPointAtDist obj (* dist (setq n (1+ n))))
	     lst
	   )
	)
      )
      (if (= (cdr (assoc 0 (entget ent))) "CIRCLE")
	(setq lst (reverse (cdr (reverse lst))))
      )
      (setq lst	  (apply 'append
			 (mapcar
			   '(lambda (x)
			      (setq x (trans x 0 ent))
			      (list (car x) (cadr x))
			    )
			   (reverse lst)
			 )
		  )
	    AcDoc (vla-get-ActiveDocument (vlax-get-acad-object))
	    Space (if (= (getvar "CVPORT") 1)
		    (vla-get-PaperSpace AcDoc)
		    (vla-get-ModelSpace AcDoc)
		  )
      )
      (vla-StartUndoMark AcDoc)
      (setq pline (vlax-Invoke Space 'addLightweightPolyline lst))

      (if (= (cdr (assoc 0 (entget ent))) "CIRCLE")
	(vla-put-Closed pline T)
      )
      (vla-put-Normal
	pline
	(vlax-3d-point (cdr (assoc 210 (entget ent))))
      )
      (vla-put-Elevation
	pline
	(cadddr (assoc 10 (entget ent)))
      )
      (vla-delete obj)
      (vla-EndUndoMark AcDoc)
    )
    (prompt "\nEntit non valide.")
  )
  (princ)
)
