;;; C:LONG_LINE  (gile)
;;; Calcule la longueur des lignes et lwpolylignes du calque spcifi

(defun c:long_line (/ clq js cnt tot nb_l nb_pl lo_l lo_pl)
  
(vl-load-com)

  (if (and (setq clq (getlayer nil))
	   (ssget "_X" (list '(0 . "LINE,LWPOLYLINE") (cons 8 clq)))
	   (setq nb_l 0
		 nb_pl 0
		 lo_l 0.0
		 lo_pl 0.0
	   )
      )
    (progn
      (vlax-for	o (vla-get-ActiveSelectionSet
		    (vla-get-ActiveDocument (vlax-get-acad-object))
		  )
	(if (= (vla-get-ObjectName o) "AcDbLine")
	  (setq	nb_l (1+ nb_l)
		lo_l (+ lo_l (vla-get-Length o))
	  )
	  (setq	nb_pl (1+ nb_pl)
		lo_pl (+ lo_pl (vla-get-Length o))
	  )
	)
      )
      (setq descr (strcat
		    "\nNom de calque..........\t"
		    clq
		    "\nNombre de lignes.......\t"
		    (itoa nb_l)
		    "\nLongueur de ligne......\t"
		    (rtos lo_l)
		    "\nNombre de polylignes...\t"
		    (itoa nb_pl)
		    "\nLongueur de polyligne..\t"
		    (rtos lo_pl)
		    "\nLongueur totale........\t"
		    (rtos (+ lo_l lo_pl))
		    "\n"
		  )
      )
      (textscr)
      (princ descr)
      (initget "Oui Non")
      (if (= (getkword
	       "\nEnregistrer dans un fichier ? [Oui/Non] < Non >: "
	     )
	     "Oui"
	  )
	(progn
	  (setq
	    file
	     (open
	       (getfiled "Crez ou slectionnez un fichier" "" "xls" 33)
	       "a"
	     )
	  )
	  (princ descr file)
	  (close file)
	)
      )
      (graphscr)
    )
  )
  (princ)
)

;;; GetLayer (gile) 03/11/07
;;; Retourne le nom du calque entr ou choisi par l'utilisateur 
;;; dans une liste droulante de la boite de dialogue ou en slectionnant
;;; un objet  l'cran.
;;; Argument : le titre (string) ou nil (dfaut : "Choisir un calque")

(defun getlayer	(titre / lay lst tmp file what_next dcl_id nom)
  (while (setq lay (tblnext "LAYER" (not lay)))
    (setq lst (cons (cdr (assoc 2 lay)) lst))
  )
  (setq	lst  (acad_strlsort lst)
	tmp  (vl-filename-mktemp "Tmp.dcl")
	file (open tmp "w")
  )
  (write-line
    (strcat
      "getlayer:dialog{label="
      (cond (titre (vl-prin1-to-string titre))
	    ("\"Choisir un calque\"")
      )
      ";initial_focus=\"tp\";
      :boxed_column{:row{
      :column{:text{label=\"Slectionner un objet\";alignment=left;}}
      :column{:button{label=\">>\";key=\"obj\";alignment=right;fixed_width=true;}
      spacer;}}
      :edit_box{key=\"tp\";edit_width=25;allow_accept=true;}
      :popup_list{key=\"lay\";edit_width=25;}
      spacer;}ok_cancel;}"
    )
    file
  )
  (close file)
  (setq dcl_id (load_dialog tmp))
  (setq what_next 2)
  (while (>= what_next 2)
    (if	(not (new_dialog "getlayer" dcl_id))
      (exit)
    )
    (start_list "lay")
    (mapcar 'add_list lst)
    (end_list)
    (or	nom
	(setq nom (vlax-ldata-get "getLayer" "n"))
	(setq nom (vlax-ldata-put "getLayer" "n" "0"))
    )
    (if	(member nom lst)
      (set_tile	"lay"
		(itoa (- (length lst) (length (member nom lst))))
      )
      (set_tile "lay" "0")
    )
    (set_tile "tp" nom)
    (action_tile "obj" "(done_dialog 3)")
    (action_tile "tp" "(setq nom $value)")
    (action_tile
      "lay"
      (strcat
	"(if (or (= $reason 1) (= $reason 4))"
	"(progn"
	"(setq nom (nth (atoi $value) lst))"
	"(set_tile \"tp\" (nth (atoi $value) lst))"
	"(mode_tile \"tp\" 2)))"
       )
    )
    (action_tile
      "accept"
      (strcat
	"(if (tblsearch \"LAYER\" nom)"
	"(progn (done_dialog 1)"
	"(vlax-ldata-put \"getLayer\" \"n\" nom))"
	"(progn"
	"(alert (strcat \"Le calque \" nom \" est introuvable.\"))"
	"(setq nom nil) (set_tile \"tp\" (vlax-ldata-get \"getLayer\" \"n\"))"
	"(mode_tile \"tp\" 2)))"
       )
    )
    (setq what_next (start_dialog))
    (cond
      ((= what_next 3)
       (if (setq nom (car (entsel)))
	 (setq nom (cdr (assoc 8 (entget nom))))
	 (setq nom nil)
       )
      )
      ((= what_next 0)
       (setq nom nil)
      )
    )
  )
  (unload_dialog dcl_id)
  (vl-file-delete tmp)
  nom
)