;; MOVEATT (gile) 07/05/08
;; Dplace les attributs
;; Par dfaut l'utilisateur slectionne les attributs un par un
;; L'option "Bloc" permet de dplacer tous les attributs des blocs slectionns

(defun c:MoveAtt
       (/ space att lst1 lst2 ss1 ss2 tmp cl lay lck txt al p1 p2)
  (vl-load-com)
  (or *acdoc*
      (setq *acdoc* (vla-get-ActiveDocument (vlax-get-acad-object)))
  )
  (initget "Bloc")
  (setq att (nentsel "\nSlectionnez un attribut ou [Bloc] <Bloc>: "))
  (if (or (null att) (= att "Bloc"))
    (if	(ssget '((0 . "INSERT") (66 . 1)))
      (vlax-for	blk (setq ss1 (vla-get-ActiveSelectionSet *acdoc*))
	(setq lst1 (append (vlax-invoke blk 'getAttributes) lst1))
      )
    )
    (progn
      (and
	(setq att (car att))
	(= (cdr (assoc 0 (entget att))) "ATTRIB")
	(setq lst1 (cons (vlax-ename->vla-object att) lst1))
	(redraw att 3)
      )
      (while (setq att (car (nentsel "\nSlectionnez un attribut: ")))
	(and
	  (= (cdr (assoc 0 (entget att))) "ATTRIB")
	  (setq lst1 (cons (vlax-ename->vla-object att) lst1))
	  (redraw att 3)
	)
      )
    )
  )
  (if lst1
    (progn
      (vla-StartUndoMark *acdoc*)
      (setq space (if (= 1 (getvar "cvport"))
		    (vla-get-PaperSpace *acdoc*)
		    (vla-get-ModelSpace *acdoc*)
		  )
	    ss2	  (ssadd)
	    tmp	  (vla-add (vla-get-Layers *acdoc*) "MoveAtt_tmp")
	    cl	  (vla-get-ActiveLayer *acdoc*)
      )
      (vla-put-ActiveLayer *acdoc* tmp)
      (foreach a lst1
	(setq lay (vla-item (vla-get-Layers *acdoc*) (vla-get-Layer a)))
	(and (= (vla-get-Lock lay) :vlax-true)
	     (setq lck (cons lay lck))
	     (vla-put-Lock lay :vlax-false)
	)
	(setq txt
	       (vla-addText
		 space
		 (vla-get-TextString a)
		 (vla-get-InsertionPoint a)
		 (vla-get-Height a)
	       )
	)
	(foreach prop '(Backward       Linetype	      LinetypeScale
			Normal	       ObliqueAngle   Rotation
			ScaleFactor    StyleName      Thickness
			TrueColor      UpsideDown
		       )
	  (vlax-put-property txt prop (vlax-get-property a prop))
	)
	(setq al (vla-get-Alignment a))
	(vla-put-Alignment txt al)
	(and (member al '(0 3 5))
	     (vla-put-InsertionPoint
	       txt
	       (vla-get-InsertionPoint a)
	     )
	)
	(or (= 0 al)
	    (vla-put-TextAlignmentPoint
	      txt
	      (vla-get-TextAlignmentPoint a)
	    )
	)
	(setq ss2  (ssadd (vlax-vla-object->ename txt) ss2)
	      lst2 (cons txt lst2)
	)
      )
      (if
	(not
	  (vl-catch-all-error-p
	    (vl-catch-all-apply
	      (function
		(lambda	()
		  (setq p1 (getpoint "\nSpcifiez le point de base: "))
		  (vl-cmdf "_.move" ss2 "" p1 pause)
		  (setq p2 (getvar "lastpoint"))
		)
	      )
	    )
	  )
	)
	 (mapcar
	   (function
	     (lambda (a)
	       (vla-move a
			 (vlax-3d-point (trans p1 1 0))
			 (vlax-3d-point (trans p2 1 0))
	       )
	     )
	   )
	   lst1
	 )
      )
      (vla-put-ActiveLayer *acdoc* cl)
      (mapcar 'vla-delete lst2)
      (vla-delete tmp)
      (mapcar (function (lambda (x) (vla-put-Lock x :vlax-true)))
	      lck
      )
      (vla-EndUndoMark *acdoc*)
    )
  )
  (princ)
)